<?php

/****************************************************************************************\
 **   @name		EXP Autos  Pro                                                  **
 **   @package          Joomla 1.6                                                      **
 **   @author		EXP TEAM::Alexey Kurguz (Grusha)                                **
 **   @copyright	Copyright (C) 2005 - 2013  EXP TEAM::Alexey Kurguz (Grusha)     **
 **   @link             http://www.feellove.eu                                          **
 **   @license		Commercial License                                              **
 \****************************************************************************************/

// No direct access.
defined('_JEXEC') or die;

jimport('joomla.application.component.modeladmin');
require_once JPATH_COMPONENT . '/helpers/expimages.php';

class ExpAutosProModelExpuser extends JModelAdmin {

    protected $text_prefix = 'COM_EXPAUTOSPRO_USERS';

    protected function canDelete($record) {
        $user = JFactory::getUser();
        /* Search Attached Files */
        $ad_params = ExpAutosProImages::getExpParams('expuser', $record->id);
        $params_file = $ad_params->get('expphoto');
        if ($params_file) {
            $link_file = ExpAutosProImages::ImgAbsPathLogo() . $params_file;
            unlink($link_file);
        }
        $filepath = ExpAutosProImages::ImgAbsPathLogo() . $record->logo;
        ExpAutosProImages::UnlinkImg($filepath);

        if (!empty($record->catid)) {
            return $user->authorise('core.delete', 'com_expautospro.expuser.' . (int) $record->catid);
        } else {
            return parent::canDelete($record);
        }
    }

    protected function canEditState($record) {
        $user = JFactory::getUser();

        if (!empty($record->catid)) {
            return $user->authorise('core.edit.state', 'com_expautospro.expuser.' . (int) $record->catid);
        } else {
            return parent::canEditState($record);
        }
    }

    public function getTable($type = 'Expuser', $prefix = 'ExpautosproTable', $config = array()) {
        return JTable::getInstance($type, $prefix, $config);
    }

    public function getForm($data = array(), $loadData = true) {
        $form = $this->loadForm('com_expautospro.expuser', 'expuser', array('control' => 'jform', 'load_data' => $loadData));
        if (empty($form)) {
            return false;
        }

        if ($this->getState('expuser.id')) {
            $form->setFieldAttribute('catid', 'action', 'core.edit');
        } else {
            $form->setFieldAttribute('catid', 'action', 'core.create');
        }

        if (!$this->canEditState((object) $data)) {
            $form->setFieldAttribute('ordering', 'disabled', 'true');
            $form->setFieldAttribute('state', 'disabled', 'true');

            $form->setFieldAttribute('ordering', 'filter', 'unset');
            $form->setFieldAttribute('state', 'filter', 'unset');
        }

        return $form;
    }

    protected function loadFormData() {
        $data = JFactory::getApplication()->getUserState('com_expautospro.edit.expuser.data', array());

        if (empty($data)) {
            $data = $this->getItem();
        }

        return $data;
    }

    protected function prepareTable($table) {
        
    }

    protected function getReorderConditions($table) {
        $condition = array();
        $condition[] = 'catid = ' . (int) $table->catid;
        $condition[] = 'state >= 0';
        return $condition;
    }

    public function save($data) {
        $id = (!empty($data['id'])) ? $data['id'] : (int) $this->getState('expuser.id');
        $isNew = true;
        $table = $this->getTable();
        if ($id > 0) {
            $table->load($id);
            $isNew = false;
        }
        //print_r($data);
        //die();
        /* Logo */
        $logo_data = JRequest::getVar('logo', '', 'files', 'array');
        $logo_del = JRequest::getString('delete_logo');
        $logo_name = JRequest::getString('logo_name');
        if (isset($logo_data['name'])) {
            $config = ExpAutosProImages::getExpParams('config', '1');
            $sufix = mktime();
            $img_name = end(explode(".", strtolower($logo_data['name'])));
            $respons_img = $data['userid'] . "_2_" . $sufix . "." . $img_name;
            $input_file = $logo_data['tmp_name'];
            $output_file = ExpAutosProImages::ImgAbsPathLogo() . $respons_img;
            $options_logo = array(
                'width' => $config->get('c_user_req_logowidth'),
                'height' => $config->get('c_user_req_logoheight'),
                'method' => $config->get('c_user_req_logoresmethod'),
                'type' => IMAGETYPE_JPEG,
                'percent' => $config->get('c_user_req_logopercent'),
                'halign' => $config->get('c_user_req_logohoralign'),
                'valign' => $config->get('c_user_req_logovertalign'),
            );
            $img_return = ExpAutosProImages::output($input_file, $output_file, $options_logo);
            if ($img_return) {
                $data['logo'] = $respons_img;
            }
        }
        if ($logo_del) {
            $filepath = ExpAutosProImages::ImgAbsPathLogo() . $logo_name;
            ExpAutosProImages::UnlinkImg($filepath);
            $data['logo'] = '';
        }
        /* Photo */
        $userphoto_data = JRequest::getVar('userphoto', '', 'files', 'array');
        $userphoto_del = JRequest::getString('delete_userphoto');
        $userphoto_name = JRequest::getString('userphoto_name');
        if (isset($userphoto_data['name'])) {
            $config = ExpAutosProImages::getExpParams('config', '1');
            $sufix = mktime();
            $img_name = end(explode(".", strtolower($userphoto_data['name'])));
            $respons_img = $data['userid'] . "_3_" . $sufix . "." . $img_name;
            $input_file = $userphoto_data['tmp_name'];
            $output_file = ExpAutosProImages::ImgAbsPathLogo() . $respons_img;
            $options_logo = array(
                'width' => $config->get('c_user_req_photowidth'),
                'height' => $config->get('c_user_req_photoheight'),
                'method' => $config->get('c_user_req_logoresmethod'),
                'type' => IMAGETYPE_JPEG,
                'percent' => $config->get('c_user_req_logopercent'),
                'halign' => $config->get('c_user_req_logohoralign'),
                'valign' => $config->get('c_user_req_logovertalign'),
            );
            $img_return = ExpAutosProImages::output($input_file, $output_file, $options_logo);
            if ($img_return) {
                $data['params']['expphoto'] = $respons_img;
                $registry = new JRegistry;
                $registry->loadArray($data['params']);
                $data['params'] = (string) $registry;
            }
        }
        if ($userphoto_del) {
            $filepath = ExpAutosProImages::ImgAbsPathLogo() . $userphoto_name;
            ExpAutosProImages::UnlinkImg($filepath);
            $data['params']['expphoto'] = '';
            $registry = new JRegistry;
            $registry->loadArray($data['params']);
            $data['params'] = (string) $registry;
        }

            if (!$table->bind($data)) {
                $this->setError($table->getError());
                return false;
            }

            $this->prepareTable($table);

            if (!$table->check()) {
                $this->setError($table->getError());
                return false;
            }

            if (!$table->store()) {
                $this->setError($table->getError());
                return false;
            }
        $this->setState('expuser.id', $table->id);
        return true;
    }

    function exptask(&$pks, $value = 1, $expmodel='') {

        $user = JFactory::getUser();
        $table = $this->getTable();
        $pks = (array) $pks;

        foreach ($pks as $i => $pk) {
            if ($table->load($pk)) {
                if (!$this->canEditState($table)) {
                    unset($pks[$i]);
                    JError::raiseWarning(403, JText::_('JLIB_APPLICATION_ERROR_EDITSTATE_NOT_PERMITTED'));
                }
            }
        }

        if (!$table->exptask($pks, $value, $user->get('id'), $expmodel)) {
            $this->setError($table->getError());
            return false;
        }

        return true;
    }
    
    function exportzip($ids) {
        $ids = implode(",", $ids);
        if ($ids) {
            $doc = new DOMDocument('1.0', 'UTF-8');
            $doc->preserveWhiteSpace = false;
            $doc->formatOutput = true;
            $root = $doc->appendChild($doc->createElement('expautospro'));
            $root->setAttribute('database', 'expautos_expuser');

            $db = JFactory::getDBO();
            $result = $db->setQuery(
                    "SELECT * FROM #__expautos_expuser WHERE id IN(" . $ids . ")"
            );
            $count = count($db->loadRow($result));
            $lists = $db->loadObjectList();
            $adm_file = null;
            foreach ($lists as $value) {
                $r = $root->appendChild($doc->createElement('general'));
                foreach ($value as $key => $val) {
                    if ($val !== NULL) {
                        $f = $r->appendChild($doc->createElement($key));
                        $f->appendChild($doc->createTextNode($val));
                    }
                }
                $value_params = new JRegistry;
                $value_params->loadString($value->params);
                $params_file = $value_params->get('expphoto');
                if ($params_file) {
                    $adm_file[] = $params_file;
                }
                if ($value->logo) {
                    $adm_file[] = $value->logo;
                }
            }
            $expxml = $doc->saveXML();
            $overwrite = true;
            $archivename = 'expautospro_admin_users_' . date("Y-m-d_H-i", time());
            $config = JFactory::getConfig();
            $destination = $config->get('tmp_path') . '/' . $archivename . '.zip';
            $zip = new ZipArchive();
            if ($zip->open($destination, $overwrite ? ZIPARCHIVE::OVERWRITE : ZIPARCHIVE::CREATE) !== true) {
                return false;
            }
            if (is_array($adm_file)) {
                $admfilepatch= ExpAutosProImages::ImgAbsPathLogo();
                foreach ($adm_file as $key => $file) {
                    $zip->addFile($admfilepatch . "/" . $file, "logo/" . basename($file));
                }
            }
            $zip->addFromString($archivename . '.xml', $expxml);
            $zip->close();
            ob_end_clean();
            header('Content-type: application/zip');
            header('Content-Disposition: attachment; filename="' . $archivename . '.zip"');
            ob_clean();
            flush();
            readfile($destination);
            unlink($destination);
            exit();
        }
    }

}
