<?php

/* * **************************************************************************************\
 * *   @name		EXP Autos  Pro                                                  **
 * *   @package          Joomla 1.6                                                      **
 * *   @author		EXP TEAM::Alexey Kurguz (Grusha)                                **
 * *   @copyright	Copyright (C) 2005 - 2013  EXP TEAM::Alexey Kurguz (Grusha)     **
 * *   @link             http://www.feellove.eu                                          **
 * *   @license		Commercial License                                              **
  \*************************************************************************************** */

// No direct access.
defined('_JEXEC') or die;

jimport('joomla.application.component.modellist');
require_once JPATH_COMPONENT . '/helpers/expimages.php';

class ExpAutosProModelImport extends JModelList {

    public function __construct($config = array()) {
        parent::__construct();
    }

    function GetFileData($sFilePath) {
        $fp = fopen($sFilePath, 'rb') or die('404! Unable to open file!');
        $buf = '';
        while (!feof($fp)) {
            $buf .= fgets($fp, 4096);
        }
        fclose($fp);
        return $buf; //returns False if failed, else the contents up to FileSize bytes.
    }

    public function importcsv($name, $select, $uploadfile) {
        $db = JFactory::getDBO();
        $postselect = $select;
        $fname = $uploadfile['name'];

        $chk_ext = explode(".", $fname);

        if (strtolower($chk_ext[1]) == "csv") {
            $filename = $uploadfile['tmp_name'];
            $handle = fopen($filename, "r");
            $lists = $db->getTableFields('#__' . $name);
            $list = array_keys($lists['#__' . $name]);
            while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
                $obj = new stdClass();
                for ($i = 0; $i < count($list); $i++) {
                    $obj->$list["$i"] = str_replace('\\"', '"', $data[$i]);
                }
                if ($postselect) {
                    $db->updateObject('#__' . $name, $obj, 'id');
                } else {
                    $db->insertObject('#__' . $name, $obj);
                }
            }
            fclose($handle);
            $this->setError($fname);
            return true;
        } else {
            $this->setError(JText::_('COM_EXPAUTOSPRO_CSVIMPORT_ERROR_NOCSVFILE_TEXT'));
            return false;
        }
    }

    public function importzip($uploadfile, $select) {
        $ziparchive = $this->_getPackageFromUpload($uploadfile);
        $ret = null;
        $zipfolder = $ziparchive['folder'];
        if (is_array($ziparchive)) {
            $ret = $this->importxml($zipfolder . "/" . $ziparchive['file'], $select, 0, 0);
        }
        if (JFolder::exists($zipfolder . "/big/")) {
            $orig_big = basename(ExpAutosProImages::ImgAbsPathBig());
            $orig_middle = basename(ExpAutosProImages::ImgAbsPathMiddle());
            $orig_thumbs = basename(ExpAutosProImages::ImgAbsPathThumbs());
            rename($zipfolder . "/big/", $zipfolder . "/" . $orig_big . "/");
            rename($zipfolder . "/middle/", $zipfolder . "/" . $orig_middle . "/");
            rename($zipfolder . "/thumbs/", $zipfolder . "/" . $orig_thumbs . "/");
            $big_copy = JFolder::copy($zipfolder . "/" . $orig_big, ExpAutosProImages::ImgAbsPathBig(), '', true);
            $middle_copy = JFolder::copy($zipfolder . "/" . $orig_middle, ExpAutosProImages::ImgAbsPathMiddle(), '', true);
            $thumbs_copy = JFolder::copy($zipfolder . "/" . $orig_thumbs, ExpAutosProImages::ImgAbsPathThumbs(), '', true);
        }
        if (JFolder::exists($zipfolder . "/files/")) {
           $orig_files = basename(ExpAutosProImages::FilesAbsPath()); 
           rename($zipfolder . "/files/", $zipfolder . "/" . $orig_files . "/");
           $files_copy = JFolder::copy($zipfolder . "/" . $orig_files, ExpAutosProImages::FilesAbsPath(), '', true);
        }
        if (JFolder::exists($zipfolder . "/logo/")) {
           $orig_logo = basename(ExpAutosProImages::ImgAbsPathLogo()); 
           rename($zipfolder . "/logo/", $zipfolder . "/" . $orig_logo . "/");
           $files_logo = JFolder::copy($zipfolder . "/" . $orig_logo, ExpAutosProImages::ImgAbsPathLogo(), '', true);
        }
        JInstallerHelper::cleanupInstall($ziparchive['zipname'], $zipfolder);
        return $ret;

        //print_r($ziparchive['file']);//folder//zipname
    }

    public function copyfiles($files, $folderfrom, $folderto) {
        foreach ($files as $val) {
            JFile::copy($folderfrom . $val, $folderto . $val, null, 1);
        }
        return true;
    }

    protected function _getPackageFromUpload($userfiles) {
        jimport('joomla.filesystem.archive');
        jimport('joomla.filesystem.file');
        $result_pack = null;
        $findxml = null;
        $userfile = $userfiles;

        if (!(bool) ini_get('file_uploads')) {
            JError::raiseWarning('', JText::_('COM_EXPAUTOSPRO_MSG_INSTALL_WARNINSTALLFILE'));
            return false;
        }

        if (!extension_loaded('zlib')) {
            JError::raiseWarning('', JText::_('COM_EXPAUTOSPRO_MSG_INSTALL_WARNINSTALLZLIB'));
            return false;
        }

        if (!is_array($userfile)) {
            JError::raiseWarning('', JText::_('COM_EXPAUTOSPRO_MSG_INSTALL_NO_FILE_SELECTED'));
            return false;
        }

        if ($userfile['error'] || $userfile['size'] < 1) {
            JError::raiseWarning('', JText::_('COM_EXPAUTOSPRO_MSG_INSTALL_WARNINSTALLUPLOADERROR'));
            return false;
        }

        $config = JFactory::getConfig();
        $tmp_dest = $config->get('tmp_path') . '/' . $userfile['name'];
        $tmp_src = $userfile['tmp_name'];

        $uploaded = JFile::upload($tmp_src, $tmp_dest);
        $tmpdir = uniqid('expimport_');

        $extractdir = JPath::clean(dirname($tmp_dest) . '/' . $tmpdir);
        $archivename = JPath::clean($tmp_dest);
        $extract_ar = JArchive::extract($tmp_dest, $extractdir);
        if ($extract_ar) {
            $findxml = JFolder::files($extractdir, '.xml$', false, false);
        }
        if ($findxml) {
            $result_pack = array('folder' => $extractdir, 'file' => $findxml[0], 'zipname' => $archivename);
        } else {
            JInstallerHelper::cleanupInstall($archivename, $extractdir);
        }
        return $result_pack;
    }

    public function importxml($uploadfile, $select, $imgres = 1, $filefrom = 1) {
        $config = ExpAutosProImages::getExpParams('config', '1');
        $table_id = null;
        $db = JFactory::getDBO();
        if ($filefrom) {
            $fname = $uploadfile['name'];
            $ftmpname = $uploadfile['tmp_name'];
        } else {
            $fname = $uploadfile;
            $ftmpname = $uploadfile;
        }
        $chk_ext = explode(".", $fname);
        if (strtolower($chk_ext[1]) == "xml") {
            $xml = simplexml_load_file($ftmpname);
            $name = $xml['database'];
            $countad = count($xml->general);
            $obj = new stdClass();
            for ($i = 0; $i < $countad; $i++) {
                $imgcat = null;
                if ($name == 'expautos_admanager') {
                    $countimg = count($xml->general[$i]->images->img);
                    $imgdatname = $xml['imgdatabase'];
                }
                if ($name == 'categories') {
                    $countast = count($xml->general[$i]->assets->ast);
                    $astdatname = $xml['assetdatabase'];
                }
                foreach ($xml->general[$i]->children() as $key => $value) {
                    if ($name == 'expautos_admanager' && $value->getName() == 'images') {
                        $obj2 = new stdClass();
                        for ($c = 0; $c < $countimg; $c++) {
                            foreach ($xml->general[$i]->images->img[$c]->children() as $key2 => $value2) {
                                $obj2->$key2 = str_replace('\\"', '"', $value2);
                            }
                            if ($select == 1) {
                                $db->updateObject('#__expautos_images', $obj2, 'id');
                            } elseif ($select == 2) {
                                if ($imgres) {
                                    $file = $obj2->name;
                                    $imgcat = $obj2->catid;
                                    $size = getimagesize($file);
                                    $type = $size['mime'];
                                    $tmpname = basename($file);
                                    //$tmpname = $fl['tmp_name'];
                                    $urlimg = parse_url($file, PHP_URL_HOST);
                                    $urlimg = str_replace(".", "_", $urlimg);
                                    $sufix = mktime();
                                    $img_name = explode(".", strtolower($obj2->name));
                                    $img_name = end($img_name);
                                    $respons_img = $sufix . "_" . $urlimg . "." . $img_name;
                                    $input_file = $this->GetFileData($file);
                                    $output_tmbfile = ExpAutosProImages::ImgAbsPathThumbs() . $respons_img;
                                    $output_middlefile = ExpAutosProImages::ImgAbsPathMiddle() . $respons_img;
                                    $output_bigfile = ExpAutosProImages::ImgAbsPathBig() . $respons_img;
                                    $options_tmbfile = array(
                                        'width' => $config->get('c_images_thumbsize_width'),
                                        'height' => $config->get('c_images_thumbsize_height'),
                                        'method' => $config->get('c_images_resmethod'),
                                        'percent' => $config->get('c_images_percent'),
                                        'halign' => $config->get('c_images_horalign'),
                                        'valign' => $config->get('c_images_vertalign'),
                                        'watermark' => 0,
                                    );
                                    $options_middlefile = array(
                                        'width' => $config->get('c_images_middlesize_width'),
                                        'height' => $config->get('c_images_middlesize_height'),
                                        'method' => $config->get('c_images_resmethod'),
                                        'percent' => $config->get('c_images_percent'),
                                        'halign' => $config->get('c_images_horalign'),
                                        'valign' => $config->get('c_images_vertalign'),
                                        'watermark' => $config->get('c_images_wt_use'),
                                    );
                                    $img_return = ExpAutosProImages::output($input_file, $output_tmbfile, $options_tmbfile);
                                    $img_return = ExpAutosProImages::output($input_file, $output_middlefile, $options_middlefile);

                                    if ($config->get('c_images_maxsize_width') == 0 && $config->get('c_images_maxsize_height') == 0 || $size[0] < $config->get('c_images_maxsize_width') || $size[1] < $config->get('c_images_maxsize_height')) {
                                        if (true) {
                                            $options_bigfile = array(
                                                'percent' => 0,
                                                'method' => $config->get('c_images_resmethod'),
                                                'width' => $size[0],
                                                'height' => $size[1],
                                                'halign' => 0,
                                                'valign' => 0,
                                                'watermark' => $config->get('c_images_wt_use'),
                                            );
                                            $img_return = ExpAutosProImages::output($input_file, $output_bigfile, $options_bigfile);
                                        } else {
                                            move_uploaded_file($input_file, $output_bigfile);
                                        }
                                    } else {

                                        $options_bigfile = array(
                                            'percent' => $config->get('c_images_percent'),
                                            'method' => $config->get('c_images_resmethod'),
                                            'width' => $config->get('c_images_maxsize_width'),
                                            'height' => $config->get('c_images_maxsize_height'),
                                            'halign' => $config->get('c_images_horalign'),
                                            'valign' => $config->get('c_images_vertalign'),
                                            'watermark' => $config->get('c_images_wt_use'),
                                        );
                                        $img_return = ExpAutosProImages::output($input_file, $output_bigfile, $options_bigfile);
                                    }

                                    if ($img_return) {
                                        $array_img[] = array('image_name' => $respons_img, 'image_ordering' => $obj2->ordering, 'image_description' => $obj2->description);
                                    }
                                }
                            } else {
                                $db->insertObject('#__expautos_images', $obj2);
                            }
                        }
                    } elseif ($name == 'categories' && $value->getName() == 'assets') {
                        $obj2 = new stdClass();
                        for ($c = 0; $c < $countast; $c++) {
                            foreach ($xml->general[$i]->assets->ast[$c]->children() as $key2 => $value2) {
                                $obj2->$key2 = str_replace('\\"', '"', $value2);
                            }
                            if ($select == 1) {
                                $db->updateObject('#__assets', $obj2, 'id');
                            } else {
                                $db->insertObject('#__assets', $obj2);
                            }
                        }
                    } else {
                        $obj->$key = str_replace('\\"', '"', $value);
                    }
                }

                if ($select == 1) {
                    $db->updateObject('#__' . $name, $obj, 'id');
                } else {
                    $db->insertObject('#__' . $name, $obj);
                    if ($select == 2 && $name == 'expautos_admanager' && $img_return) {
                        if (is_array($array_img)) {
                            $table_id = $db->insertid();
                            $c_img = count($array_img);
                            for ($i = 0; $i < $c_img; ++$i) {
                                $objimg = new stdClass();
                                $objimg->catid = (int) $table_id;
                                $objimg->name = $array_img[$i]['image_name'];
                                $objimg->ordering = $array_img[$i]['image_ordering'];
                                $objimg->description = $array_img[$i]['image_description'];
                                $db->insertObject('#__expautos_images', $objimg);
                            }
                        }
                    }
                }
                if ($select == 2 && $name == 'expautos_admanager' && $table_id) {
                    ExpAutosProImages::getExpdataImg($table_id);
                }
                if ($db->getErrorNum()) {
                    JError::raiseWarning(500, $db->getErrorMsg());
                }
            }
            $this->setError($fname);
            if($db->getErrorNum()){
                return false;
            }else{
                return true;
            }
        } else {
            $this->setError(JText::_('COM_EXPAUTOSPRO_CSVIMPORT_ERROR_NOXMLFILE_TEXT'));
            return false;
        }
    }

}