<?php
/* * **************************************************************************************\
 * *   @name		EXP Autos  Pro                                                  **
 * *   @package          Joomla 1.6                                                      **
 * *   @author		EXP TEAM::Alexey Kurguz (Grusha)                                **
 * *   @copyright	Copyright (C) 2005 - 2013  EXP TEAM::Alexey Kurguz (Grusha)     **
 * *   @link             http://www.feellove.eu                                          **
 * *   @license		Commercial License                                              **
  \*************************************************************************************** */


defined('JPATH_BASE') or die;

jimport('joomla.html.html');
jimport('joomla.form.formfield');
jimport('joomla.form.helper');
JFormHelper::loadFieldClass('list');
require_once JPATH_SITE . '/components/com_expautospro/helpers/expparams.php';

class JFormFieldExpequipment extends JFormField {

    /**
     * The form field type.
     *
     * @var		string
     * @since	1.6
     */
    protected $type = 'Expequipment';

    /**
     * Method to get the field options.
     *
     * @return	array	The field option objects.
     * @since	1.6
     */
    public function getInput($data = 0) {
        $expparams = ExpAutosProExpparams::getExpParams('config', 1);
        $equipcolumn = $expparams->get('c_admanager_add_equipcolumn', 2);
        $expmobenable = $expparams->get('c_admanager_add_usemobile', 0);
        $mob_return = null;
        if ($expmobenable) {
            $mob_return = ExpAutosProExpparams::expmobile_detect();
        }
        $patchs = explode(',', $this->form->getValue('equipment'));
        $exppostcat = JRequest::getInt('expcat', 0);
        if ($exppostcat) {
            $expcat = JRequest::getInt('expcat', 0);
        } else {
            $expcat = $this->form->getValue('catid');
        }
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id, name');
        $query->from('#__expautos_catequipment');
        $query->where('catid = ' . (int) $expcat);
        $query->where('state = 1');
        $query->order('ordering');
// Get the options.
        $db->setQuery($query);

        $catequipment = $db->loadObjectList();

// Check for a database error.
        if ($db->getErrorNum()) {
            JError::raiseWarning(500, $db->getErrorMsg());
        }
//print_r($this->form->getValue('equipment'));
//die();
        ?>
        <?php if ($mob_return): ?>
            <?php
            foreach ($catequipment as $eqcat) {
                $query2 = $db->getQuery(true);
                $query2->select('id, name');
                $query2->from('#__expautos_equipment');
                $query2->where('catid = ' . (int) $eqcat->id);
                $query2->where('state = 1');
                $query2->order('ordering');
// Get the options.
                $db->setQuery($query2);

                $equipment = $db->loadObjectList();
                $c = 0;
                $kr = $equipcolumn;
                ?>
                <div data-role="fieldcontain">
                    <fieldset data-role="controlgroup">
                        <legend><strong><?php echo $eqcat->name; ?></strong></legend>
                        <?php
                        for ($i = 0, $n = count($equipment); $i < $n; $i++) {
                            ?>
                            <input data-mini="true" id="equipment<?php echo $equipment[$i]->id; ?>" name="jform[equipment][<?php echo $equipment[$i]->id; ?>]" class="custom" type="checkbox" <?php
                    foreach ($patchs as $patch) {
                        if ($patch == $equipment[$i]->id) {
                            echo' checked="checked" ';
                        }
                    }
                            ?>  value="<?php echo $equipment[$i]->id; ?>" />

                            <label for="equipment<?php echo $equipment[$i]->id; ?>">

                                <?php echo $equipment[$i]->name; ?>

                            </label>

                        <?php } ?>
                    </fieldset>
                </div>
            <?php } ?>
        <?php else: ?>
            <table class="expequiptable">
                <?php
                foreach ($catequipment as $eqcat) {
                    $query2 = $db->getQuery(true);
                    $query2->select('id, name');
                    $query2->from('#__expautos_equipment');
                    $query2->where('catid = ' . (int) $eqcat->id);
                    $query2->where('state = 1');
                    $query2->order('ordering');
                    // Get the options.
                    $db->setQuery($query2);

                    $equipment = $db->loadObjectList();
                    $c = 0;
                    $kr = $equipcolumn;
                    ?>
                    <tr>
                        <td colspan="<?php echo $kr * 2; ?>" class="expadd_equip">
                            <h3><?php echo $eqcat->name; ?></h3>
                        </td>
                    </tr>
                    <?php
                    for ($i = 0, $n = count($equipment); $i < $n; $i++) {
                        if (($c % $kr) == 0) {
                            echo '</tr>';
                            echo '<tr>';
                        }
                        ?>
                        <td>
                            <input data-mini="true" id="equipment<?php echo $equipment[$i]->id; ?>" name="jform[equipment][<?php echo $equipment[$i]->id; ?>]" class="custom" type="checkbox" id="jform_equipment[<?php echo $equipment[$i]->id; ?>]" <?php
                    foreach ($patchs as $patch) {
                        if ($patch == $equipment[$i]->id) {
                            echo' checked="checked" ';
                        }
                    }
                        ?>  value="<?php echo $equipment[$i]->id; ?>" />

                        </td>

                        <td class="key" style="width:300px; text-align:left;">

                            <label for="equipment<?php echo $equipment[$i]->id; ?>">

                                <?php echo $equipment[$i]->name; ?>

                            </label>

                        </td>

                        <?php
                        $c++;
                    }
                }
                ?>

            </tr>
            </table>
        <?php endif; ?>
        <?php
    }

}
