<?php

/****************************************************************************************\
 **   @name		EXP Autos  Pro                                                  **
 **   @package          Joomla 1.6                                                      **
 **   @author		EXP TEAM::Alexey Kurguz (Grusha)                                **
 **   @copyright	Copyright (C) 2005 - 2013  EXP TEAM::Alexey Kurguz (Grusha)     **
 **   @link             http://www.feellove.eu                                          **
 **   @license		Commercial License                                              **
 \****************************************************************************************/


defined('JPATH_BASE') or die;

jimport('joomla.html.html');
jimport('joomla.form.formfield');
jimport('joomla.form.helper');
JFormHelper::loadFieldClass('list');

class JFormFieldExpuserlevel extends JFormFieldList {

    /**
     * The form field type.
     *
     * @var		string
     * @since	1.6
     */
    protected $type = 'Expuserlevel';

    /**
     * Method to get the field options.
     *
     * @return	array	The field option objects.
     * @since	1.6
     */
    public function getInput($data=0) {
        // Initialize variables.
        $options = array();
        $document = JFactory::getDocument();
        $userParams = JComponentHelper::getParams('com_users');
        $def_user = $userParams->get('new_usertype');
        $sel_level = JRequest::getInt('expuserlevel', 0);
        if($sel_level){
            $val_id = $sel_level;
        }else{
            $val_id = $def_user;
        }
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        
        $query->select('a.userlevel');
        $query->from('`#__expautos_userlevel` AS a');

        $query->select('ug.id As value, ug.title AS text');
        $query->join('LEFT', '#__usergroups AS ug ON ug.id = a.userlevel');
        $query->where('a.state > 0');
        $query->order('ug.title');

        // Get the options.
        $db->setQuery($query);

        $options = $db->loadObjectList();
        if($options){
            // Check for a database error.
            if ($db->getErrorNum()) {
                JError::raiseWarning(500, $db->getErrorMsg());
            }
            $onchange = (string) $this->element['onchange'];
            $attr = " onchange = '".$onchange."'";
            $returnval = JHtml::_('select.genericlist', $options, $this->name, trim($attr), 'value', 'text', $val_id);

            return $returnval;
        }else{
            return false;
        }
    }

}
