<?php

/****************************************************************************************\
 **   @name		EXP Autos  Pro                                                  **
 **   @package          Joomla 1.6                                                      **
 **   @author		EXP TEAM::Alexey Kurguz (Grusha)                                **
 **   @copyright	Copyright (C) 2005 - 2013  EXP TEAM::Alexey Kurguz (Grusha)     **
 **   @link             http://www.feellove.eu                                          **
 **   @license		Commercial License                                              **
 \****************************************************************************************/

//no direct access
defined('_JEXEC') or die;

require_once JPATH_ROOT . '/components/com_expautospro/helpers/expparams.php';

class ModExpautosDealerSearch {
    
    public static function getItemid() {
        $expitemid = ExpAutosProExpparams::getExpLinkItemid();
        return $expitemid;
    }
    
    public static function getCountry($module_id,$params) {
        $jq_chained = $params->get('jq_chained', 0);
        $mod_id = 'expbutton' . $module_id;
        if ($jq_chained) {
            $expchange_func = ' expchangejq';
        } else {
            $expchange_func = ' expchange';
        }
        $select_country = $params->get('country');
        if($select_country){
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('name As countryname');
            $query->from('#__expautos_country');
            $query->where('id = '.$select_country);
            $query->where('state = 1');
            $query->order('ordering');

            // Get the options.
            $db->setQuery($query);

            $return = $db->loadResult();
        }else{
            $options = array();
            $app = JFactory::getApplication();
            $countryid = (int) JRequest::getInt('country', '-2');
            if($countryid >= 0){
                $setcountry = (int)$app->setUserState('expdealercountry',$countryid);
            }
            $val_id = (int) $app->getUserState('expdealercountry');
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('id As value, name As text');
            $query->from('#__expautos_country');
            $query->where('state = 1');
            $query->order('name');

            // Get the options.
            $db->setQuery($query);

            $options = $db->loadObjectList();

            // Check for a database error.
            if ($db->getErrorNum()) {
                JError::raiseWarning(500, $db->getErrorMsg());
            }
            $onchange = ' class="'.$params->get('input_class').' chzn-expselectdealersearch" ';
            if($params->get('useexpstate')){
                $url = 'index.php?option=com_expautospro&view=expuser&format=ajax&expcountry_id=';
                $onchange .= ' onchange="' . $expchange_func . '(this.value,\''.$url.'\',\'expstate'.$module_id.'\',\'' . $mod_id . '\')"';
            }
            if (!isset($data)) {
                array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_DEALERSEARCH_SELECT_COUNTRY_TEXT')));
                $return = JHtml::_('select.genericlist', $options, 'country', $onchange, 'value', 'text', $val_id, 'country'.$module_id);
            }
        }

        return $return;
    }
    
    public static function getExpState($module_id,$params) {
        $jq_chained = $params->get('jq_chained', 0);
        $mod_id = 'expbutton' . $module_id;
        if ($jq_chained) {
            $expchange_func = ' expchangejq';
        } else {
            $expchange_func = ' expchange';
        }
        $options = array();
        $app = JFactory::getApplication();
        $setcountry = '';
        $select_country = $params->get('country');
        if($select_country){
            $setcountry = $select_country;
        }else{
            $setcountry = (int)JRequest::getInt('country',0);
        }
        $val_id = '';
        if($setcountry){
            $expstateid = (int) JRequest::getInt('expstate', '-2');
            if($expstateid >= 0){
                $setexpstate = (int)$app->setUserState('expdealerstateval',$expstateid);
            }
            $val_id = (int) $app->getUserState('expdealerstateval');
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('id As value, name As text');
            $query->from('#__expautos_state');
            $query->where('state = 1');
            $query->where('catid = '.$setcountry);
            $query->order('name');

            // Get the options.
            $db->setQuery($query);

            $options = $db->loadObjectList();

            // Check for a database error.
            if ($db->getErrorNum()) {
                JError::raiseWarning(500, $db->getErrorMsg());
            }
        }
        $onchange = ' class="'.$params->get('input_class').' chzn-expselectdealersearch" ';
        if($params->get('usecity')){
            $url = 'index.php?option=com_expautospro&view=expuser&format=ajax&state_id=';
            $onchange .= ' onchange="' . $expchange_func . '(this.value,\''.$url.'\',\'city'.$module_id.'\',\'' . $mod_id . '\');"';
        }
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_DEALERSEARCH_SELECT_STATE_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'expstate', $onchange, 'value', 'text', $val_id, 'expstate'.$module_id);
        }

        return $return;
    }
    
    public static function getCity($module_id,$params) {
        $options = array();
        $app = JFactory::getApplication();
        $setexpstate = (int)$app->getUserState('expdealerstateval');
        $val_id = '';
        if($setexpstate){
            $expcityid = (int) JRequest::getInt('city', '-2');
            if($expcityid >= 0){
                $setexpcity = (int)$app->setUserState('expdealercity',$expcityid);
            }
            $val_id = (int) $app->getUserState('expdealercity');
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('id As value, city_name As text');
            $query->from('#__expautos_cities');
            $query->where('state = 1');
            $query->where('catid = '.$setexpstate);
            $query->order('city_name');

            // Get the options.
            $db->setQuery($query);

            $options = $db->loadObjectList();

            // Check for a database error.
            if ($db->getErrorNum()) {
                JError::raiseWarning(500, $db->getErrorMsg());
            }
        }
        $onchange = ' class="'.$params->get('input_class').' chzn-expselectdealersearch" ';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_DEALERSEARCH_SELECT_CITY_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'city', $onchange, 'value', 'text', $val_id, 'city'.$module_id);
        }
        return $return;
    }
    
    public static function getDealer($module_id,$params) {
        $options = array();
        $expparams = ExpAutosProExpparams::getExpparams('config',1);
        $explevel = implode(',', $expparams->get('c_admanager_dealerlspage_users'));
        $sortfield = "us.username";
        $app = JFactory::getApplication();
        /*
        $expuserid = (int) JRequest::getInt('userid', 0);
        if($expuserid){
            $val_id = $expuserid;
        }
         */

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('a.companyname');
        $query->from('#__expautos_expuser as a');
        
        $query->select('us.id AS value, us.username AS text, us.name AS jname, us.email AS jemail');
        $query->join('LEFT', '#__users AS us ON us.id = a.userid');

        $query->select('map2.user_id, COUNT(map2.group_id) AS group_count');
        $query->join('LEFT', '#__user_usergroup_map AS map2 ON map2.user_id = a.userid');
        $query->group('a.userid');

        $query->join('LEFT', '#__usergroups AS g2 ON g2.id = map2.group_id');
        $query->where('map2.group_id IN ('.$explevel.') ');
        $query->order($sortfield);
        

        // Get the options.
        $db->setQuery($query);

        $options = $db->loadObjectList();

        // Check for a database error.
        if ($db->getErrorNum()) {
            JError::raiseWarning(500, $db->getErrorMsg());
        }
        $val_id = '';
        $onchange = ' class="'.$params->get('input_class').' chzn-expselectdealersearch" ';
        if (!isset($data)) {
            array_unshift($options, JHtml::_('select.option', '0', JText::_('MOD_EXPAUTOSPRO_DEALERSEARCH_FORM_USER_SELECT_TEXT')));
            $return = JHtml::_('select.genericlist', $options, 'userid', $onchange, 'value', 'text', $val_id, 'userid'.$module_id);
        }

        return $return;
    }
    
    public static function getZipCode($module_id,$params) {
        $app = JFactory::getApplication();
        $zipcodeid = (string) JRequest::getString('zipcode', '-2');
        if($zipcodeid != '-2'){
            $setzipcode = (string)$app->setUserState('expdealerzipcode',$zipcodeid);
        }
        $val_id = (string) $app->getUserState('expdealerzipcode');
        $return = '<input id="modexpsearch_zipcode'.$module_id.'" type="text" name="zipcode" class="inputbox '.$params->get('input_class').'"  value="'.$val_id.'" />';
        return $return;
    }

}
?>

